﻿/* キャラクターの向きを示すクラス */
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
namespace PixelLiner.PixelLinerLib {
    public enum AIM : uint {
        L = 0,
        T = 1,
        R = 2,
        B = 3,
        LT = 4,
        TR = 5,
        BL = 6,
        RB = 7,
        ALL = 8
    }
    public class CAim {
        static string[] Astring__;
        public static string[] Astring {
            get {
                if (Astring__ == null) {
                    Astring__ = new string[8] {
                    "left",
                    "top",
                    "right",
                    "bottom",
                    "top left",
                    "top right",
                    "bottom left",
                    "bottom right"
                    };
                }
                return Astring__;
            }
        }

        // ======================================================== 
        // MARK: public var 
        // ========================================================
        public static bool valid (int _d) {
            return X.BTW (0, _d, 8);
        }
        public static bool valid (uint _d) {
            return X.BTW (0, (int) _d, 8);
        }
        public static bool valid (AIM _d) {
            return true;
        }
        static int XD4 (int dir) {
            dir = (dir) % 4;
            return ((((dir) + 1) % 2) * ((dir) - 1));
        }
        static int YD4 (int dir) {
            dir = (dir) % 4;
            return dir == 1 ? (1) : (dir == 3 ? -1 : 0);
        }
        public static int XDN (int dir) {
            // -1,1, -1,1
            return (dir) % 2 == 1 ? 1 : -1;
        }
        public static int YDN (int dir) {
            // -1,-1,1,1
            return (int) (dir / 2) % 2 == 1 ? -1 : 1;
        }
        public static int _XD (int _d, int v = 1) {
            return (_d >= 4 ? XDN (_d - 4) : XD4 (_d)) * v;
        }
        public static int _YD (int _d, int v = 1) {
            return (_d >= 4 ? YDN (_d - 4) : YD4 (_d)) * v;
        }
        public static int XDN (AIM dir) { return XDN ((int) dir); }
        public static int YDN (AIM dir) { return YDN ((int) dir); }
        public static int _XD (AIM _d, int v = 1) { return _XD ((int) _d, v); }
        public static int _YD (AIM _d, int v = 1) { return _YD ((int) _d, v); }
        public static AIM get_aim_r (float x1, float y1, float x2, float y2) {
            float dx = x2 - x1,
                dy = y2 - y1,
                ax = X.Abs (dx),
                ay = X.Abs (dy);
            // float tan_xy = X.Abs(dy) / X.Abs(dx);

            if (ay > X.TAN_22_5 * ax) {
                return dx > 0 ? AIM.R : AIM.L;
            } else if (ay < X.TAN_67_5 * ax) {
                return dx > 0 ? (dy < 0 ? AIM.RB : AIM.TR) : (dy < 0 ? AIM.BL : AIM.LT);
            }
            return dy < 0 ? AIM.B : AIM.T;
        }
    }
}